﻿
class Program {

    static IEnumerator<int> GetValueList(int firstValue, int secondValue) {
        yield return firstValue * 2;
        for (int i = firstValue; i <= secondValue; i++) {
            var tripleValue = i * 3;
            Console.WriteLine($"GetValueList: got intermediate value {tripleValue}");
            yield return tripleValue;
        }
        yield return secondValue * 2;
    }

    static void Main(string[] args) {
        {
            var e = GetValueList(1, 2);
            while (e.MoveNext()) {
                Console.WriteLine($"Main: got {e.Current}");
            }
        }

        Console.WriteLine();

        {
            var a = new A { TargetValue = 2 };
            var e = a.GetValueList(1);
            while (e.MoveNext()) {
                Console.WriteLine($"Main: got {e.Current}");
            }
        }
    }
}

class A {
    public int TargetValue;

    public IEnumerator<int> GetValueList(int firstValue) {
        yield return firstValue * 2;
        for (int i = firstValue; i <= TargetValue; i++) {
            var tripleValue = i * 3;
            Console.WriteLine($"GetValueList: got intermediate value {tripleValue}");
            yield return tripleValue;
        }
        yield return TargetValue * 2;
    }
}
