﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TwoArraysViaIteratorMethods {
	class A : IEnumerable<int> {
		private int[] x1 = { 1, 2 };
		private int[] x2 = { 3, 4, 5 };

		System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator() {
			return GetEnumerator();
		}

		public IEnumerator<int> GetEnumerator() {
			for (int i = 0; i < x1.Length; i++) {
				yield return x1[i];
			}
			for (int i = 0; i < x2.Length; i++) {
				yield return x2[i];
			}
		}
	}

	class Program {
		static void Main(string[] args) {
			int[] ints = { 10, 20 };

			var e = ints.GetEnumerator();
			try {
				Console.WriteLine("on int[]: before while: e.Current == {0}", e.Current);
			} catch (Exception ex) {
				Console.WriteLine("{0}: {1}", ex.GetType(), ex.Message);
			}
			while (e.MoveNext()) {
				Console.WriteLine("on int[]: in while: e.Current == {0}", e.Current);
			}
			try {
				Console.WriteLine("on int[]: after while: e.Current == {0}", e.Current);
			} catch (Exception ex) {
				Console.WriteLine("{0}: {1}", ex.GetType(), ex.Message);
			}

			//
			Console.WriteLine();
			//

			A a = new A();
			Console.WriteLine("on A: before foreach");
			foreach (int i in a) {
				Console.WriteLine("on A: got {0}", i);
			}
			Console.WriteLine("on A: after foreach");

			//
			Console.WriteLine();
			//

			e = a.GetEnumerator();
			try {
				Console.WriteLine("on A: before while: e.Current == {0}", e.Current);
			} catch (Exception ex) {
				Console.WriteLine("{0}: {1}", ex.GetType(), ex.Message);
			}
			while (e.MoveNext()) {
				Console.WriteLine("on A: in while: e.Current == {0}", e.Current);
			}
			try {
				Console.WriteLine("on A: after while: e.Current == {0}", e.Current);
			} catch (Exception ex) {
				Console.WriteLine("{0}: {1}", ex.GetType(), ex.Message);
			}
		}
	}
}
